// 10.07.2008
// Poszukiwanie turniejw 3-ec na 22 wierzchokach
// docza graph3ec.cpp (z definicjami uywanych, a rzadziej lub wcale nie zmienianych funkcji
// Autor: Przemysaw Gordinowicz
// Pomys: autor+Pawe Praat

#include <stdio.h>
#include <time.h>
#include <string.h>

#define order     22
#define size      15 
//size = (((order * (order-1)) / 2) + 15) / 16;
// 7 8 9 10 11 12 14 15 16 18 19 21 22
#define str_length 420
//str_length = (((3*order+4)*(3*order+3))/2+5)/6+3 + 3 (jeli order > 20)
// 208 233 260 289 319 353 386 421 457 494 533 574 616
#define short_size 4
//11 - 4, 12 - 5, 13 - 5, 14 - 6

#define max_hash_size 799999

#pragma warning(disable : 4996)

#define HELPTEXT \
" Proba wyznaczenia turnieju 3-ec na 15 wierzcholkach.\
\n\
-b - graf poczatkowy (inicjalizacja)\
\n\
-p nr1 nr2 ile - preselekcja okreslonej ilosci wierzcholkow aktualnie o numerach od nr1 do nr2\
\n\
-v nr - nr przetwarzanego wierzcholka (dla wygody i do okreslenia std. nazw plikow)\
\n\
-g nr1 -G nr2 - zakres (numery) wstawianych grafow 2-ec (przetwarzanie: 0 - T7, 1-14 - T9, 15-1097 - T10)\
 \
\n\
-n nr - ilosc konfiguracji grafow T10 przy ktorej robic wstawianie \"pelne\"\
\n\
-h nr1 -H nr2 -d nr3 - zakres (numery) grafow wstawianych w miejsce wyroznionych wierzcholkow\
oraz roznica stopni do jakiej wybierac wyrozniony wierzcholek (jego \"przewaga\")\
\n\
-l -r - czy wierzcholki wyroznione maja byc stopnia nizszego (-l) (9,10) czy wyzszego (-r) (12,13) \
- oba powoduja stopien dowolny\
\n\
-i file_in -o file_out - nazwy plikow (gdy inne niz domyslne)\
\n\
-m nr1 -M nr2 -s nr3 - czytanie z pliku grafow o nr od nr1 do nr2 pomijajac (zawsze) nr3\
\n"

//poniewa stworzyem "potwora" trzeba rozbi kod na kilka plikw 
#include "Graph3ec.cpp"

// tu jeszcze kilka globalnych zmiennych - ale uywanych tylko poniej
int leftg, rightg;

TGraph StrToGraph(const char * graph_text) {
// tumaczy napis (format Brandana McKey'a) na graf (z dwustanowymi krawdziami)
// zakada "dobry" porzdek krawdzi
// zmiany - jako, ze kodujemy turniej trzeba wybrac wiecej "dodatkow"
	TGraph g = CreateGraph();
    TVertex u, v, w, bit, number, S1, T, M1, M2;
    
	TVertex n = *graph_text-63;
	graph_text++;

	if (n == 63) {
		n = *graph_text++-63;
		n = (n << 6) | (*graph_text++ - 63);
		n = (n << 6) | (*graph_text++ - 63);		
	}

	TEdgeStatus ** tabl = new TEdgeStatus * [n];
	for (u = 0 ; u < n ; u++)
		tabl[u] = new TEdgeStatus[n];
	
	TPermPointer p = new TVertex[order];
	TPermPointer q = new TVertex[n];
	TPermPointer r = new TVertex[n];
	TDegreePointer d1 = new signed char[n];
	TDegreePointer d2 = new signed char[n];
	TDegreePointer d3 = new signed char[n];
	for (u = 0; u < n; u++) {
		r[u] = -1;
		q[u] = -1;
		d1[u] = d2[u] = d3[u] = 0;
		tabl[u][u] = 0;
	}


	bit = 5;
	number = *graph_text-63;
	graph_text++;

	for (u = 1 ; u < n ; u++) {
		for (v = 0 ; v < u ; v++) {
			if (bit == -1) {
				bit = 5;
				number = *graph_text-63;
				graph_text++;
			}
			if (tabl[v][u] = tabl[u][v] = (number >> bit) & 1) {
				d3[u]++;
				d3[v]++;
			}
			bit--;
		}
	}
	// wierzchoek S1 (wyrniajcy rda ) ma najwikszy stopie (order+1)
	S1 = 0;
	for (u = 1; u < n; u++) 
		if (d3[u] > d3[S1]) S1 = u;
	// ssiedzi S1 to S2 (nieuywany) i "rda" - zapisujemy w p (bdziemy zmienia ich permutacje) - stan si wierzchokami docelowymi
	for (u = 0, v = 0; u < n; u++)
		if (tabl[S1][u] && d3[u] < d3[S1]) p[v++] = u;
	// wierzchoek T (wyrniajcy ujcia) ma najwikszy stopie mniejszy ni S1 (order)
	for (T = 0;  d3[T] >= d3[S1]; T++);
	for (u = T+1; u < n; u++) 
		if (d3[u] < d3[S1] && d3[u] > d3[T]) T = u;


	// przejcia - ssiaduj ze rdami i ujciami, nie ssiaduj z S1 (oczywiste) ani z T
	// zapisa w q
	for (v = 0; v < order; v++) {
		for (u = 0; u < n; u++)
			if (tabl[p[v]][u] && d3[u] < d3[T] && !tabl[T][u]) {
				q[p[v]] = u;
				q[u] = p[v];
			}
	}


	// ssiedzi wierzchokw z q bdcy ssiadami T - to wierzchoki uj
	// zapisa w r
	for (v = 0; v < order; v++) {
		for (u = 0; u < T; u++)
			if (tabl[q[p[v]]][u] && tabl[T][u]) {
				r[p[v]] = u;
				r[u] = p[v];
			}
		for (u = T+1; u < n; u++)
			if (tabl[q[p[v]]][u] && tabl[T][u]) {
				r[p[v]] = u;
				r[u] = p[v];
			}
	}
	// M1 i M2 to jedyne obok S1, S2 i T wierzchoki, ktre maj q[.] == r[.] == -1
	// dotatkowo d3[.] < order;
	for (u = 0; u < n; u++)
		if (q[u] == -1 && r[u] == -1 && d3[u] < d3[T] ) { 
			M1 = u; 
			break;
		}
	for (u = M1+1; u < n; u++)
		if (q[u] == -1 && r[u] == -1 && d3[u] < d3[T] ) { 
			M2 = u; 
			break;
		}
	if (d3[M1] < d3[M2]) { // zamiana
		TVertex temp = M1;
		M1 = M2;
		M2 = temp;
	}
	// wierzchoki poczone z M1 s wyrnione - podnie im d1 o 2*order
	for (u = 0; u < n; u++)
		if (tabl[M1][u]) {
			d1[q[u]] += 2*order; 
			tabl[M1][u] = tabl[u][M1] = 0;
			d3[u]--;
		}
	// wierzchoki poczone z M2 s ju przetworzone - podnie im d1 o order;
	for (u = 0; u < n; u++)
		if (tabl[M2][u]) {
			d1[q[u]] += order; 
			tabl[M2][u] = tabl[u][M2] = 0;
			d3[u]--;
		}

	// nanie poczenia grafu (S,T) jako graf skierowany na S
	for (v = 0; v < order; v++) {
		for (u = v+1; u < order; u++) {
			if (tabl[p[v]][r[p[u]]]) {
				tabl[p[v]][p[u]] = 1;
				d1[p[v]]++;
				d2[p[u]]++;
			}
			else if (tabl[r[p[v]]][p[u]]) {
				tabl[p[u]][p[v]] = 1;
				d1[p[u]]++;
				d2[p[v]]++;
			}
		}
		// wspczynniki sortowania (do d3)
		// wierzchoki wyrnione d3 - rednia ze stopni (ale z leftg, rightg)
		// wierzchoki inne d3 - mniejszy (zmiana)  ze stopni
		if (d1[p[v]] < order || d1[p[v]] > 3 * order)
			d3[p[v]] = d1[p[v]] % order < d2[p[v]] ? d1[p[v]] % order : d2[p[v]];
		else { // rednia
			if (leftg || rightg)
				d3[p[v]] = ((leftg * (d1[p[v]] % order)) + (rightg * d2[p[v]])) / (leftg + rightg);
			else d3[p[v]] = 0;
		}
		// jescze dodajmy sum stopni
		//## uwaga - jeszcze bd poniej 127
		d3[p[v]] = d3[p[v]] + d1[p[v]] + d2[p[v]]; 

	}
	
	// mam ju wszystko - teraz posortowa p[v] z uwagi na sum stopni powikszon o wspczynnik sortowania
	// czyli d3.
	// insertion sort (wystarczy, bo order < 28);
	for (v = 1; v < order; v++) { // cig 0..v-1 jest ju posortowany
		w = p[v];
		for (u = v-1; u >= 0 && (d3[w] > d3[p[u]] || ((d3[w] == d3[p[u]]) && (d1[w]+d2[w] > d1[p[u]]+d2[p[u]]))); u--)
			p[u+1] = p[u];
		p[u+1] = w;
	}

	// tworzenie "naszego" grafu
	for (u = 0; u < order; u++) {
		for (v = u+1; v < order; v++)
			if (tabl[p[u]][p[v]]) SetEdgeStatus(g.e_arr, u, v, 1);
			else if (tabl[p[v]][p[u]]) SetEdgeStatus(g.e_arr, u, v, 2);
		g.d1[u] = d1[p[u]];
		g.d2[u] = d2[p[u]];
	}

	delete[] d3;
	delete[] d2;
	delete[] d1;
	delete[] r;
	delete[] p;
	for (u = 0 ; u < n ; u++)
		delete[] tabl[u];
	delete[] tabl;

	return g;
}


void ProcessVertex(TVertex vert2, int g_start, int g_stop, int g_number, int h_start, int h_stop, int h_sup) {
	// zmiany turniej

	// uwaga: h_start, h_stop pomidzy 0 a 14
	signed int j=0, k = 100000;
	signed int g_start9 = g_start > 14 ? -1 : (g_start ? g_start : (g_stop ? 1 : -1));
	signed int g_stop9 = g_start9 == -1 ? -1 : (g_stop > 14 ? 14 : g_stop);
	signed int g_start10 = (g_stop > 14) ? (g_start > 15 ? g_start : 15) : -1;
	//signed int g_stop10 = (g_stop > 14) ? (g_stop < 1097 ? g_stop : 1097) : -1;
	signed int g_stop10 = (g_stop > 14) ? (g_stop < 98 ? g_stop : 98) : -1;
	
	signed int h_start9 = (h_start > 14) || (h_stop) ? -1 : (h_start < 1 ? 1 : h_start);
	signed int h_stop9 = h_start > 14 ? -1 : (h_stop > 14 ? 14 : h_stop);

	TVertex vert;
	TVertex u, v, x, z0, z1, z2, z3, z4, z5;
	THashTable *dest;
    TGraph g0;
    TPermPointer p0, p1, p2, p3;
	unsigned short * b;

    p0 = new TVertex[order];
    p1 = new TVertex[order];
    p2 = new TVertex[order];
    p3 = new TVertex[order];
	b = new unsigned short[order];

	g_stop -= 15;	// do warunkw z 10-kami
	dest = new THashTable(max_hash_size); 
	dest->fname = fname_out;
	// czytamy jeden graf z pliku
	for (g0 = ReadGraph(fname_in); g0.e_arr; g0 = ReadGraph(fname_in)) {
		vert = vert2;
		// tu dobra wierzchoek "inaczej"
		while (g0.d1[vert] >= order) vert++;
		if (vert != vert2) { // chyba jeszcze inny warunek
			z2 = leftg ? (g0.d1[vert2] % order) : 0;
			z2 += rightg ? g0.d2[vert2] : z2;
			if (leftg) z2 = (z2+1)/2; // rednia ze stopni 
			if (g0.d1[vert] > g0.d2[vert]) {
				z1 = g0.d1[vert]; // wikszy ze stopni
				z0 = g0.d2[vert]; // mniejszy ze stopni
			}
			else {
				z0 = g0.d1[vert]; // mniejszy ze stopni
				z1 = g0.d2[vert]; // wikszy ze stopni
			}
			if (z0 < z2 || z1 <= z2 + h_sup) // mniejszy ma by nie gorszy, wikszy ma by lepszy o ponad h_sup
				vert = vert2;
		}

		z0 = z1 = z2 = 0;
		for (v = 0; v < vert; v++)
			switch (GetEdgeStatus(g0.e_arr, v, vert)) {
				case 0: p0[z0++] = v; break;
				case 2: p1[z1++] = v; break; // czyli nastpniki vert
				default: p2[z2++] = v;       // case 1
			}
		for (v = vert+1; v < order; v++)
			switch (GetEdgeStatus(g0.e_arr, vert, v)) {
				case 0: p0[z0++] = v; break;
				case 1: p1[z1++] = v; break; // nastpniki vert
				default: p2[z2++] = v;       // case 2
			}
		z3 = z1; z4 = z2; z5 = 0;

		// najpierw wierzchoki ju "uywane"
		for (v = 0; v < z0; v++)
			if (g0.d1[p0[v]] + g0.d2[p0[v]] > 5)
				p1[z3++] = p2[z4++] = p0[v];
		// teraz wierzchoki "swobodne" - ich nie trzeba bra duo
		for (v = 0; v < z0; v++)
			if (g0.d1[p0[v]] + g0.d2[p0[v]] <= 5) {
				z5++;
				p1[z3++] = p2[z4++] = p0[v];
			}

		// sortowanie wierzchokw w tablicach wedug ilosci ich wzajemnych powiza
		// najpierw p1
		// najpierw policzenie powiza (pewniaki - b * z3) 
		z3 = z0 - z5;
		memset(b, 0, order * sizeof(unsigned short));
		for (u = 0; u < z1; u++) {
			for (v = u+1; v < z1; v++)
				//if (p1[u] < p1[v] ? GetEdgeStatus(g0.e_arr, p1[u], p1[v]) : GetEdgeStatus(g0.e_arr, p1[v], p1[u])) {
				if (GetEdgeStatus(g0.e_arr, p1[u], p1[v])) {
					b[p1[u]]+=z3+1;
					b[p1[v]]+=z3+1;
				}
			for (v = z1; v < z1+z3; v++)
				if (p1[u] < p1[v] ? GetEdgeStatus(g0.e_arr, p1[u], p1[v]) : GetEdgeStatus(g0.e_arr, p1[v], p1[u])) {
					b[p1[u]]++;
					b[p1[v]]+=z3+1;
				}
		}
		for (u = z1; u < z1+z3-1; u++)
			for (v = u+1; v < z1+z3; v++)
				//if (p1[u] < p1[v] ? GetEdgeStatus(g0.e_arr, p1[u], p1[v]) : GetEdgeStatus(g0.e_arr, p1[v], p1[u])) {
				if (GetEdgeStatus(g0.e_arr, p1[u], p1[v])) {
					b[p1[u]]++;
					b[p1[v]]++;
				}
		// mam ju wszystko - teraz posortowa p1[v] z uwagi na sum stopni 1 i 2 (czyli b)
		// insertion sort (wystarczy, bo order < 28);
		// najpierw w obrebie z1
		for (v = 1; v < z1; v++) { // cig 0..v-1 jest ju posortowany
			x = p1[v];
			for (u = v-1; u >= 0 && b[x] > b[p1[u]]; u--)
				p1[u+1] = p1[u];
			p1[u+1] = x;
		}
		// teraz z1 do z1+z3 (z1+z0-z5)
		for (v = z1+1; v < z1+z3; v++) { // cig 0..v-1 jest ju posortowany
			x = p1[v];
			for (u = v-1; u >= z1 && b[x] > b[p1[u]]; u--)
				p1[u+1] = p1[u];
			p1[u+1] = x;
		}
		// teraz to samo dla p2
		for (u = 0; u < z2; u++) {
			for (v = u+1; v < z2; v++)
				//if (p2[u] < p2[v] ? GetEdgeStatus(g0.e_arr, p2[u], p2[v]) : GetEdgeStatus(g0.e_arr, p2[v], p2[u])) {
				if (GetEdgeStatus(g0.e_arr, p2[u], p2[v])) {
					b[p2[u]]+=z3+1;
					b[p2[v]]+=z3+1;
				}
			for (v = z2; v < z2+z3; v++)
				if (p2[u] < p2[v] ? GetEdgeStatus(g0.e_arr, p2[u], p2[v]) : GetEdgeStatus(g0.e_arr, p2[v], p2[u])) {
					b[p2[u]]++;
					b[p2[v]]+=z3+1;
				}
		}
		for (u = z2; u < z2+z3-1; u++)
			for (v = u+1; v < z2+z3; v++)
				//if (p2[u] < p2[v] ? GetEdgeStatus(g0.e_arr, p2[u], p2[v]) : GetEdgeStatus(g0.e_arr, p2[v], p2[u])) {
				if (GetEdgeStatus(g0.e_arr, p2[u], p2[v])) {
					b[p2[u]]++;
					b[p2[v]]++;
				}
		// mam ju wszystko - teraz posortowa p2[v] z uwagi na sum stopni 1 i 2 (czyli b)
		// insertion sort (wystarczy, bo order < 28);
		// najpierw w obrebie z2
		for (v = 1; v < z2; v++) { // cig 0..v-1 jest ju posortowany
			x = p2[v];
			for (u = v-1; u >= 0 && b[x] > b[p2[u]]; u--)
				p2[u+1] = p2[u];
			p2[u+1] = x;
		}
		// teraz z1 do z1+z3 (z1+z0-z5)
		for (v = z2+1; v < z2+z3; v++) { // cig 0..v-1 jest ju posortowany
			x = p2[v];
			for (u = v-1; u >= z2 && b[x] > b[p2[u]]; u--)
				p2[u+1] = p2[u];
			p2[u+1] = x;
		}

		if (g0.d1[vert] >= order) { // vert jest wyrniony
			// vert bdzie przetworzony
			g0.d1[vert] += order;
			
			// mona nie rozwaa
			/*
			if (!h_start) { // obsadzamy 7-ki
				if (leftg && z1 <= 7)
					EmbedIsoGraph7(g0, vert, 1, z0, z1, z5, p1, dest); // nastpniki, gdy vert ma mie stopie wyjciowy 7
				if (rightg && z2 <= 7)
					EmbedIsoGraph7(g0, vert, 2, z0, z2, z5, p2, dest); // poprzedniki, gdy vert ma mie stopie wejciowy 7
			}*/
			
			if (h_stop) {// obsadzamy 9-ki
				if (leftg && z1 <= 9)
					EmbedIsoGraph9(g0, vert, 1, z0, z1, z5, p1, dest, h_start9, h_stop9); // nastpniki, gdy vert ma mie stopie wyjciowy 9
				if (rightg && z2 <= 9)
					EmbedIsoGraph9(g0, vert, 2, z0, z2, z5, p2, dest, h_start9, h_stop9); // poprzedniki, gdy vert ma mie stopie wejciowy 9
			}
		}
		else {
			//vert bdzie przetworzony
			g0.d1[vert] += 3*order;
			
			// mona nie rozwaa
			/*
			if (!g_start) { // obsadzamy 7-ki
				if (z1 <= 7)
					EmbedIsoGraph7(g0, vert, 1, z0, z1, z5, p1, dest); // nastpniki, gdy vert ma mie stopie wyjciowy 7
				if (z2 <= 7)
					EmbedIsoGraph7(g0, vert, 2, z0, z2, z5, p2, dest); // poprzedniki, gdy vert ma mie stopie wejciowy 7
			}*/
			
			if (g_start9 > -1) {// obsadzamy 9-ki
				if (z1 <= 9)
					EmbedIsoGraph9(g0, vert, 1, z0, z1, z5, p1, dest, g_start9, g_stop9); // nastpniki, gdy vert ma mie stopie wyjciowy 10
				if (z2 <= 9)
					EmbedIsoGraph9(g0, vert, 2, z0, z2, z5, p2, dest, g_start9, g_stop9); // poprzedniki, gdy vert ma mie stopie wejciowy 10
			}

			/*if (g_start10 > -1) {// obsadzamy 10-ki
				if (z1 <= 10 && (z2 > 10 || z2 < z1 || (z2 == z1 && (b[p2[0]] <= b[p1[0]]))))
					EmbedIsoGraph10(g0, vert, 1, z0, z1, z5, p1, dest, g_start10, g_stop10); // nastpniki, gdy vert ma mie stopie wyjciowy 10
				if (z2 <= 10 && (z1 > 10 || z1 < z2 || (z2 == z1 && (b[p1[0]] <= b[p2[0]]))))
					EmbedIsoGraph10(g0, vert, 2, z0, z2, z5, p2, dest, g_start10, g_stop10); // poprzedniki, gdy vert ma mie stopie wejciowy 10
			}*/

			if (g_start10 > -1) {// obsadzamy 10-ki
				if (z1 <= 10 && (z2 > 10 || z2 < z1 || (z2 == z1 && (b[p2[0]] <= b[p1[0]]))))
					EmbedIsoGraph10p(g0, vert, 1, z0, z1, z5, p1, dest, g_number, g_start10-15, g_stop10-15);  // nastpniki, gdy vert ma mie stopie wyjciowy 10
				if (z2 <= 10 && (z1 > 10 || z1 < z2 || (z2 == z1 && (b[p1[0]] <= b[p2[0]]))))
					EmbedIsoGraph10p(g0, vert, 2, z0, z2, z5, p2, dest, g_number, g_start10-15, g_stop10-15); // poprzedniki, gdy vert ma mie stopie wejciowy 10
			}
		}
		DestroyGraph(g0);
		j++;
		if (!(j % k)) printf(".");
		if (!(j % (10*k))) {
			printf("%d\t%d\t", j/10/k, dest->data_count);
			fflush(stdout);
		}
	}
	if (dest->data_count) dest->WriteGraphList(fname_out);
	if (vert >= order-1 && dest->data_count) dest->WriteReport("raport3ec.txt");
	cmp2_count = dest->comp2_count;
	delete dest;
	
	delete [] b;
    delete [] p3;
    delete [] p2;
    delete [] p1;
    delete [] p0;
}

void InitialConfiguration(int g_start, int g_stop) {
// zmiany - turniej
// tworzy konfiguracj pocztkow z turniejw o numerach pomidzy g_start a g_stop
// poprzez umieszczenie ich jako nastpnikw wierzchoka 0 (uwaga - grafy mog by rznych rozmiarw)
	signed int i;
	signed int g_start9 = g_start > 14 ? -1 : (g_start ? g_start : (g_stop ? 1 : -1));
	signed int g_stop9 = g_start9 == -1 ? -1 : (g_stop > 14 ? 14 : g_stop);
	signed int g_start10 = (g_stop > 14) ? (g_start > 15 ? g_start : 15) : -1;
	signed int g_stop10 = (g_stop > 14) ? (g_stop < 1097 ? g_stop : 1097) : -1;

    TVertex u, v;
	THashTable *dest;
    TGraph g0;
    TPermPointer p1, p2;

    p1 = new TVertex[order];
    p2 = new TVertex[order];

	dest = new THashTable(1);
	dest->fname = fname_out;
	if (!g_start) {	// bd 7-ki
		g0 = CreateGraph();
		// wierzchoek "0" ma 7 nastpnikw
		for (u = 1, v = 0; u < 8; u++) {
			p1[v++] = u;
			SetEdgeStatus(g0.e_arr, 0, u, 1);
			g0.d1[u]--;
			g0.d2[u]++;
		}
		g0.d1[0] = 7 + 3*order; //+przetworzony
		// reszta to jego poprzednicy
		for (u = 8; u < order; u++) {
			SetEdgeStatus(g0.e_arr, 0, u, 2);
			g0.d1[u]++;
			g0.d2[u]--;
		}
		g0.d2[0] = order-8;

		EmbedGraph(graphs2ec->table[0]->graph, g0, 7, p1);
		dest->InsertGraphWC(g0, 0);
		DestroyGraph(g0);
	}
	if (g_start9 > -1) for (i = g_start9; i <= g_stop9; i++) { // bd 9-ki
		g0 = CreateGraph();
		// wierzchoek "0" ma 9 nastpnikw
		for (u = 1, v = 0; u < 10; u++) {
			p1[v++] = u;
			SetEdgeStatus(g0.e_arr, 0, u, 1);
			g0.d1[u]--;
			g0.d2[u]++;
		}
		g0.d1[0] = 9 + 3*order; //+przetworzony
		// reszta to jego poprzednicy
		for (u = 10; u < order; u++) {
			SetEdgeStatus(g0.e_arr, 0, u, 2);
			g0.d1[u]++;
			g0.d2[u]--;
		}
		g0.d2[0] = order-10;

		EmbedGraph(graphs2ec->table[i]->graph, g0, 9, p1);
		dest->InsertGraphWC(g0, 0);

		DestroyGraph(g0);
	}
	
	if (g_start10 > -1) for (i = g_start10; i <= g_stop10; i++) { // bd 10-ki
		g0 = CreateGraph();
		// wierzchoek "0" ma 10 nastpnikw
		for (u = 1, v = 0; u < 11; u++) {
			p1[v++] = u;
			SetEdgeStatus(g0.e_arr, 0, u, 1);
			g0.d1[u]--;
			g0.d2[u]++;
		}
		g0.d1[0] = 9 + 3*order; //+przetworzony
		// reszta to jego poprzednicy
		for (u = 11; u < order; u++) {
			SetEdgeStatus(g0.e_arr, 0, u, 2);
			g0.d1[u]++;
			g0.d2[u]--;
		}
		g0.d2[0] = order-10;

		EmbedGraph(graphs2ec->table[i]->graph, g0, 10, p1);
		dest->InsertGraphWC(g0, 0);

		DestroyGraph(g0);
	}

	if (dest->data_count) dest->WriteGraphList(fname_out);
	delete dest;
	
    delete [] p2;
    delete [] p1;
}

int main(int argc, char * argv[])
{
    int v, i, init, p1, p2, p3;
    int g_start, g_stop, g_number;
	int h_start, h_stop, h_sup;
	char * arg;

	
	time_t t = time(NULL);
    printf("%.8s\n", ctime(&t)+11);

	v = init = p1 = p2 = p3 = 0;
	fname_in[0] = fname_out[0] = 0;
	h_start = h_stop = 0;
	h_sup = 11;
	g_start = 0; g_stop = 14;
	g_number = 1721;
	if (argc == 1) {
		printf(HELPTEXT);
		return 0;
	}
	else for (i = 1; i < argc; i++) {
		arg = argv[i];
		if (*arg == '-') switch (*(++arg)) {
			case 'b' : init = 1; break;
			case 'l' : leftg = 1; break;
			case 'r' : rightg = 1; break;
			case 'v' : sscanf(argv[++i], "%d", &v); break;
			case 'p' :
				sscanf(argv[++i], "%d", &p1);
				sscanf(argv[++i], "%d", &p2);
				sscanf(argv[++i], "%d", &p3);
				if (!fname_in[0]) sprintf(fname_in, "file%da.txt", p1);
				if (!fname_out[0]) sprintf(fname_out, "file%db.txt", p1);
				break;
			case 'i' : strcpy(fname_in, argv[++i]); break;
			case 'o' : strcpy(fname_out, argv[++i]); break;
			case 'g' : sscanf(argv[++i], "%d", &g_start); break;
			case 'G' : sscanf(argv[++i], "%d", &g_stop); break;
			case 'n' : sscanf(argv[++i], "%d", &g_number); break;
			case 'h' : sscanf(argv[++i], "%d", &h_start); break;
			case 'H' : sscanf(argv[++i], "%d", &h_stop); break;
			case 'd' : sscanf(argv[++i], "%d", &h_sup); break;
			case 'm' : sscanf(argv[++i], "%lld", &pos_min); break;
			case 'M' : sscanf(argv[++i], "%lld", &pos_max); break;
			case 's' : sscanf(argv[++i], "%lld", &pos_skip); break;
		}
	}
	if (!fname_in[0]) sprintf(fname_in, "file%db.txt", v);
	if (!fname_out[0]) sprintf(fname_out, "file%da.txt", v+1);

	if (init) {
		graphs2ec = new THashTable(1098);
		ReadGraphs1ec(); //??
		ReadGraphs2ec();
		InitialConfiguration(g_start, g_stop);
	}
	else if (!p3) {
		graphs2ec = new THashTable(1098);
		ReadGraphs1ec();
		ReadGraphs2ec();
		if (g_stop > 14) ConstructGraphs(10, &graphs10, graphs10_2ec, count10); //, 15, 1097);
	    
		ProcessVertex(v, g_start, g_stop, g_number, h_start, h_stop, h_sup);
		DeleteShortGraphTreeList(graphs10_2ec, 84);
	}
	else SelectVertices(p1, p2, p3);

    t = time(NULL);
	printf("\nPrzeczytano: %llu\n", read_count);
	printf("Zapisano : %llu\n", write_count);
	printf("Odrzucono (3-ec): %llu\n", test3_count);
	printf("Odrzucono (stopnie): %llu\n", degree_count);
	printf("Duplikaty : %llu\n", cmp2_count);
	printf("Porowniania : %llu\n", comp_count);
    printf("%.8s\n", ctime(&t)+11);
   
    return 0;
}
